/* 
	Problem izdelovalec - odjemalec
	Zagotoviti je treba, da odjemalec pobira izdelke iz skladi"s"ca v enakem vrstnem redu kot jih 
	izdelovalec postavlja vanj. Izdelovalec ne sme dodajati izdelkov, "ce je skladi"s"ce polno, 
	odjemalec pa jih ne sme jemati, "ce je skladi"s"ce prazno. Vzemimo, da je v skladi"s"cu eno 
	samo mesto. 
   
	dve klju"cavnici, ne moremo zakleniti v eni in odkleniti v drugi funkciji - se ne prevede
*/

#include <stdio.h>
#include <omp.h> 

int skladisce;
omp_lock_t lock_izdeluj;
omp_lock_t lock_jemlji;
  
void izdelovalec();
void odjemalec();

void main(void)  
{
	omp_init_lock(&lock_izdeluj);
	omp_init_lock(&lock_jemlji);

	#pragma omp parallel sections
	{
		#pragma omp section
		izdelovalec();
		#pragma omp section
		odjemalec();
	}

	omp_destroy_lock(&lock_izdeluj);
	omp_destroy_lock(&lock_jemlji);
}

void izdelovalec()
{
	int i = 0;

	printf("Proizvajalec\n");
	while (i < 50) 
	{
		i = i + 1;
		omp_set_lock(&lock_izdeluj);
		skladisce = i;
		omp_unset_lock(&lock_jemlji);
	}
}

void odjemalec()
{
	int i, v;

	printf("Porabnik\n");
	for (i = 0; i < 50; i++) 
	{
		omp_set_lock(&lock_jemlji);
		v = skladisce;
		omp_unset_lock(&lock_izdeluj);
		printf("Dobil: %d\n",v);
	}
}
