/* 
	Poenostavljen problem petih filozofov, petih kroznikov spagetov in petih vilic
		
	Za okroglo mizo zboruje pet filozofov, ki v vec ciklih razmisljajo, so lacni, jejo, 
	potem spet razmisljajo, ... Jedo spagete, ki jih ima vsak na svojem krozniku. Za jedenje
	spagetov potrebuje vsak dvoje vilice, ki pa jih imajo skupaj na voljo samo pet! 

	uporaba svojih vilic in vilic naslednjega soseda, mozen smrtni objem	
*/

#include <stdio.h>
#include <windows.h>
#include <omp.h> 

void zborovanje(void);

omp_lock_t mutex_vilice[5];
omp_lock_t mutex_pobiranje_vilic;
 
main()  
{
	int i;

	omp_init_lock(&mutex_pobiranje_vilic);
	for (i=0; i<5; i++)
		omp_init_lock(&mutex_vilice[i]);

	#pragma omp parallel for
	for (i=0; i<5; i++)
		zborovanje();

	omp_destroy_lock(&mutex_pobiranje_vilic);
	for (i=0; i<5; i++)
		omp_destroy_lock(&mutex_vilice[i]);
}

void zborovanje(void)
{
	int f;
	int jed = 0;

	f = omp_get_thread_num();
	printf("Filozof %d je prisedel.\n", f);

	while (jed < 5) 
	{
		printf("Filozof %d razmislja.\n", f);
		Sleep(f*5);
		printf("Filozof %d je lacen.\n", f);
		omp_set_lock(&mutex_pobiranje_vilic);
		omp_set_lock(&mutex_vilice[f]);
		omp_set_lock(&mutex_vilice[(f+1)%5]);
		omp_unset_lock(&mutex_pobiranje_vilic);
		printf("Filozof %d je.\n", f);
		jed++;
		Sleep(10);
		printf("Filozof %d je nehal jesti.\n", 5);
		omp_unset_lock(&mutex_vilice[(f+1)%5]);
		omp_unset_lock(&mutex_vilice[f]);
	}
}
